﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SlidePuzzle
{
    public partial class Stopwatch : UserControl
    {       
        Timer _timer;
        public Time Time { get; private set; }

        public Stopwatch()
        {
            InitializeComponent();
            _timer = new Timer
            {
                Interval = 1000
            };

            _timer.Tick += OnTick;
            Time = new Time();
            UpdateLabels();
        }

        private void OnTick(object sender, EventArgs e)
        {
            Time.Seconds++;
            if (Time.Seconds > 59)
            {
                Time.Minutes++;
                Time.Seconds = 0;

            }
            if (Time.Minutes > 59)
            {
                Time.Hours++;
                Time.Minutes = 0;
            }

            UpdateLabels();
        }

        public void Start()
        {
            _timer.Start();
        }

        public void Pause()
        {
            _timer.Stop();
        }

        public void Reset()
        {
            _timer.Stop();
            Time.Hours = Time.Minutes = Time.Seconds = 0;
            UpdateLabels();

        }

        private void UpdateLabels()
        {

            _lblHours.Text = String.Format("{0:D2}", Time.Hours);
            _lblMinutes.Text = String.Format("{0:D2}", Time.Minutes);
            _lblSeconds.Text = String.Format("{0:D2}", Time.Seconds);

        }
    }

    public class Time
    {
        public int Hours { get; internal set; }
        public int Minutes { get; internal set; }
        public int Seconds { get; internal set; }
    }
}